@echo off

rem /*
rem 
rem Copyright 2001 Concurrent Software System Lab (CSSL) Computer Science
rem Department The University of Illinois at Chicago All Rights Reserved.
rem 
rem The contents of this file are made available under and subject to the
rem Research Use Rights of the Sun Community Source License v 3.0 (the
rem "License"). Software distributed under the License is distributed on an
rem "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
rem See the License for the specific language governing rights and
rem limitations under the License.
rem 
rem Contributor: Concurrent Software System Lab, UIC.
rem 
rem Version 1.00
rem 
rem */

set INTF_NAME=GSP
set IMPL_NAME=%INTF_NAME%Impl
set MESSAGE_NAME=Message
set MSP_NAME=MSP
set AGENT_INFO=Agent
set PLAN_NAME=Plan
set GOAL_NAME=Goal
set LISTENER_NAME=Listener
set AGENTUI_NAME=SellerConsole
set AGENT_NAME=Seller
set MYAGENT_NAME=TrainTicketSeller
set PKG0=agent
set PKG1=generic
set PKG2=seller
set PKG3=sellerUI
set PKG4=trainTicketSeller

set USAGE=usage: build%INTF_NAME% [-usage] [-help] [-src src] [-jdk jdk] [-jini jini]

set ARG_LIST=(-src -jdk -jini)

set SRC_HOME=C:\CSSL\MyJava\Mad-Pro
set JDK_HOME=C:\jdk1.3.1
set JINI_HOME=C:\CSSL\MyJini\jini1_1

rem Parse the argument list
:loop
if "%1"=="" goto endloop
set ARG=%1

for %%f in %ARG_LIST% do if %ARG%==%%f shift
if "%1"=="" goto endloop

if -usage==%ARG% goto showUsage
if -help==%ARG% goto showHelp

if -src==%ARG% set SRC_HOME=%1
if -jdk==%ARG% set JDK_HOME=%1
if -jini==%ARG% set JINI_HOME=%1

shift
goto loop
:endloop

echo =========================
echo build %MYAGENT_NAME%.jar
echo =========================

set OLD_Path=%Path%
set OLD_CLASSPATH=%CLASSPATH%
set Path=%JDK_HOME%\bin;%Path%
set CLASSPATH=
echo.
java -version
echo.

set SRC_DIR=%SRC_HOME%\src
set CLASS_DIR=%SRC_HOME%\classes
set PKG_DIR=%PKG0%\%PKG4%
set JAR_DIR=%SRC_HOME%\jars

@echo on
rem delete old files ...
del %CLASS_DIR%\agent\generic\*.*
del %CLASS_DIR%\agent\seller\*.*
del %CLASS_DIR%\agent\sellerUI\*.*
del %CLASS_DIR%\agent\trainTicketSeller\*.*
@echo off
echo.

echo Building TrainTicketSeller agent class ...
javac -classpath %JINI_HOME%\lib\jini-core.jar;%JINI_HOME%\lib\jini-ext.jar;%JINI_HOME%\lib\sun-util.jar;%CLASS_DIR%;. -d %CLASS_DIR% %SRC_DIR%\%PKG0%\%PKG4%\%MYAGENT_NAME%.java

pause

rem Execute rmic to create the stub and skeleton of the remote service

rem *** Setting -classpath for rmic over-writes the SYSTEM
rem *** classpath; so you'll get errors saying it can't find the
rem *** most basic classes in java (ex. java.lang.Object). This is 
rem *** because the system classpath includes only your application
rem *** classpath. Set the classpath as an evironment variable and
rem *** the system classpath will be left intact.

set CLASSPATH=%JINI_HOME%\lib\jini-core.jar;%JINI_HOME%\lib\jini-ext.jar;%JINI_HOME%\lib\sun-util.jar;%CLASS_DIR%
echo Building %IMPL_NAME%_Stub ...
rmic -keep -d %CLASS_DIR% %PKG0%.%PKG1%.%IMPL_NAME%
echo Building %LISTENER_NAME%_Stub ...
rmic -keep -d %CLASS_DIR% %PKG0%.%PKG1%.%LISTENER_NAME%
set CLASSPATH=

rem *** Because security restrictions do not allow the use of
rem *** absolute paths, relative paths must be used to point to
rem *** Class-Path download extension files in a manifest. Because
rem *** of this fact, any Jini JAR files needed by this program
rem *** are copied to this program's JAR directory
xcopy %JINI_HOME%\lib\jini-core.jar %JAR_DIR%
xcopy %JINI_HOME%\lib\jini-ext.jar %JAR_DIR%
xcopy %JINI_HOME%\lib\sun-util.jar %JAR_DIR%

rem *** Create the manifest for the executable jar file
rem *** NOTE: THE MANIFEST DOES NOT ALLOW TRAILING SPACES!!!
echo Building Executable JAR Manifest ...
echo Manifest-Version: 1.0>%SRC_DIR%\%PKG_DIR%\%MYAGENT_NAME%.mf
echo Main-Class: %PKG0%.%PKG4%.%MYAGENT_NAME%>>%SRC_DIR%\%PKG_DIR%\%MYAGENT_NAME%.mf
echo Class-Path: jini-core.jar jini-ext.jar sun-util.jar>>%SRC_DIR%\%PKG_DIR%\%MYAGENT_NAME%.mf
rem *** Set the variables needed to create the executable jar file
set JAR_CLASS_0=%PKG0%/%PKG1%/%INTF_NAME%.class
set JAR_CLASS_1=%PKG0%/%PKG1%/%IMPL_NAME%.class
set JAR_CLASS_2=%PKG0%/%PKG1%/%IMPL_NAME%_Skel.class
set JAR_CLASS_3=%PKG0%/%PKG1%/%IMPL_NAME%_Stub.class
set JAR_CLASS_4=%PKG0%/%PKG1%/%IMPL_NAME%$ServiceIDListenerImpl.class
set JAR_CLASS_5=%PKG0%/%PKG1%/%IMPL_NAME%$LookupDiscoveryListener.class
set JAR_CLASS_6=%PKG0%/%PKG1%/%IMPL_NAME%$LookupInfo.class
set JAR_CLASS_7=%PKG0%/%PKG1%/%IMPL_NAME%$StoreLookupInfoThread.class
set JAR_CLASS_8=%PKG0%/%PKG1%/%LISTENER_NAME%.class
set JAR_CLASS_9=%PKG0%/%PKG1%/%LISTENER_NAME%_Skel.class
set JAR_CLASS_10=%PKG0%/%PKG1%/%LISTENER_NAME%_Stub.class
set JAR_CLASS_11=%PKG0%/%PKG1%/%MESSAGE_NAME%.class
set JAR_CLASS_12=%PKG0%/%PKG1%/%MSP_NAME%.class
set JAR_CLASS_13=%PKG0%/%PKG1%/%AGENT_INFO%.class
set JAR_CLASS_14=%PKG0%/%PKG1%/%GOAL_NAME%.class
set JAR_CLASS_15=%PKG0%/%PKG1%/%PLAN_NAME%.class
set JAR_CLASS_16=%PKG0%/%PKG2%/%AGENT_NAME%.class
set JAR_CLASS_17=%PKG0%/%PKG2%/%AGENT_NAME%$1.class
set JAR_CLASS_18=%PKG0%/%PKG2%/%AGENT_NAME%$2.class
set JAR_CLASS_19=%PKG0%/%PKG2%/%AGENT_NAME%$SellerListener.class
set JAR_CLASS_20=%PKG0%/%PKG3%/%AGENTUI_NAME%.class
set JAR_CLASS_21=%PKG0%/%PKG3%/%AGENTUI_NAME%$1.class
set JAR_CLASS_22=%PKG0%/%PKG3%/%AGENTUI_NAME%$MenuActionListener.class
set JAR_CLASS_23=%PKG0%/%PKG3%/%AGENTUI_NAME%$TabListener.class
set JAR_CLASS_24=%PKG0%/%PKG3%/%AGENTUI_NAME%$AgentLogoListCellRenderer.class
set JAR_CLASS_25=%PKG0%/%PKG3%/%AGENTUI_NAME%$AgentListSelectionListener.class
set JAR_CLASS_26=%PKG0%/%PKG4%/%MYAGENT_NAME%.class
set JAR_CLASS_27=%PKG0%/%PKG4%/%MYAGENT_NAME%$1.class
set JAR_CLASS_28=%PKG0%/%PKG4%/%MYAGENT_NAME%$GoalTreeSelectionListener.class
set JAR_CLASS_29=%PKG0%/%PKG4%/%MYAGENT_NAME%$ButtonActionListener.class
set JAR_CLASS_30=%PKG0%/%PKG4%/%MYAGENT_NAME%$MyGoal.class
set JAR_CLASS_31=%PKG0%/%PKG4%/%MYAGENT_NAME%$%PLAN_NAME%ToBeFoundByBuyer.class
set JAR_CLASS_32=%PKG0%/%PKG4%/%MYAGENT_NAME%$%PLAN_NAME%ToFindBuyer.class
set JAR_CLASS_33=%PKG0%/%PKG4%/%MYAGENT_NAME%$%PLAN_NAME%ToBeAskedPrice.class
set JAR_CLASS_34=%PKG0%/%PKG4%/%MYAGENT_NAME%$%PLAN_NAME%ToBeNegotiatedPrice.class


rem *** Create the executable jar file
echo Building Executable JAR File ...
jar cvfm %JAR_DIR%\%MYAGENT_NAME%.jar %SRC_DIR%\%PKG_DIR%\%MYAGENT_NAME%.mf -C %CLASS_DIR% %JAR_CLASS_0%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_1%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_2%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_3%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_4%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_5%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_6%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_7%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_8%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_9%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_10%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_11%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_12%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_13%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_14%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_15%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_16%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_17%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_18%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_19%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_20%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_21%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_22%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_23%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_24%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_25%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_26%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_27%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_28%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_29%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_30%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_31%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_32%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_33%
jar uvf %JAR_DIR%\%MYAGENT_NAME%.jar -C %CLASS_DIR% %JAR_CLASS_34%

rem *** Create the manifest for the service downloadable jar file
rem *** NOTE: THE MANIFEST DOES NOT ALLOW TRAILING SPACES!!!
echo Building Service Downloadable JAR Manifest ...
echo Manifest-Version: 1.0>%SRC_DIR%\%PKG_DIR%\%MYAGENT_NAME%-srvc-dl.mf
rem *** Set the variables needed to create the service downloadable jar file
set SRVC_DL_CLASS_0=%PKG0%/%PKG1%/%INTF_NAME%.class
set SRVC_DL_CLASS_1=%PKG0%/%PKG1%/%IMPL_NAME%_Stub.class
set SRVC_DL_CLASS_2=%PKG0%/%PKG1%/%LISTENER_NAME%_Stub.class
rem *** Create the service downloadable jar file
echo Building Service Downloadable JAR File ...
jar cvfm %JAR_DIR%\%MYAGENT_NAME%-srvc-dl.jar %SRC_DIR%\%PKG_DIR%\%MYAGENT_NAME%-srvc-dl.mf -C %CLASS_DIR% %SRVC_DL_CLASS_0%
jar uvf %JAR_DIR%\%MYAGENT_NAME%-srvc-dl.jar -C %CLASS_DIR% %SRVC_DL_CLASS_1%
jar uvf %JAR_DIR%\%MYAGENT_NAME%-srvc-dl.jar -C %CLASS_DIR% %SRVC_DL_CLASS_2%

rem *** Create the manifest for the attribute downloadable jar file
rem *** NOTE: THE MANIFEST DOES NOT ALLOW TRAILING SPACES!!!
echo Building Attribute Downloadable JAR Manifest ...
echo Manifest-Version: 1.0>%SRC_DIR%\%PKG_DIR%\%MYAGENT_NAME%-attr-dl.mf
rem *** Set the variables needed to create the attribute downloadable jar file
set ATTR_DL_CLASS_0=net/jini/lookup/entry/ServiceInfo.class
set ATTR_DL_CLASS_1=com/sun/jini/lookup/entry/BasicServiceType.class
rem *** Extract the Jini-specific attribute classes from the appropriate jar file
echo Extracting the Jini Attribute Class Files ...
cd %CLASS_DIR%
jar xvf %JINI_HOME%\lib\jini-ext.jar net/jini/lookup/entry/ServiceInfo.class
jar xvf %JINI_HOME%\lib\sun-util.jar com/sun/jini/lookup/entry/BasicServiceType.class
cd %SRC_DIR%\%PKG_DIR%
rem *** Create the attribute downloadable jar file
echo Building Attribute Downloadable JAR File ...
jar cvfm %JAR_DIR%\%MYAGENT_NAME%-attr-dl.jar %SRC_DIR%\%PKG_DIR%\%MYAGENT_NAME%-attr-dl.mf -C %CLASS_DIR% %ATTR_DL_CLASS_0%
jar uvf %JAR_DIR%\%MYAGENT_NAME%-attr-dl.jar -C %CLASS_DIR% %ATTR_DL_CLASS_1%


rem Copy the download jar files to the downloadable site
echo.
echo ** Copy %MYAGENT_NAME%-srvc-dl.jar to %JINI_HOME%\lib\
xcopy %JAR_DIR%\%MYAGENT_NAME%-srvc-dl.jar %JINI_HOME%\lib\
echo.
rem xcopy %JAR_DIR%\%MYAGENT_NAME%-attr-dl.jar %JINI_HOME%\lib\


rem *** END of Script ***
goto endScript

rem *** USAGE ***
:showUsage
echo.
echo %USAGE%
echo.
goto exitScript

rem *** HELP ***
:showHelp
echo.
echo %USAGE%
echo where options include:
echo.
echo  -src     [base dir of example source,class,jar files]
echo           Example: enter d:\home, then policy files, tools and 
echo                    source files assumed under d:\home\src
echo                    class files assumed under d:\home\classes
echo                    jar files assumed under d:\home\jars
echo           (Default = %SRC_HOME%).
echo  -jdk     [base dir of JDK]
echo           Example: enter d:\jdk1.2, bin assumed in d:\jdk1.2\bin
echo           (Default = %JDK_HOME%).
echo  -jini    [base dir of jini files]
echo           Example: enter d:\jini1_1, jars assumed in d:\jini1_1\lib
echo           (Default = %JINI_HOME%).
echo.
goto exitScript

:endScript
set CLASSPATH=%OLD_CLASSPATH%
set Path=%OLD_Path%
goto exitScript

:exitScript
echo ===========================
echo build TrainTicketSeller done!
echo ===========================
pause
exit
